program PatcherROMDisk;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp
  { you can add units after this };

type

  { TMyApplication }

  TMyApplication = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    procedure WriteHelp; virtual;
  end;

{ TMyApplication }

procedure TMyApplication.DoRun;
var
  ErrorMsg: String;
  Fin1, Fin2, FOut : File;

  NumRead, NumWritten : Word;

  buffer : array[0..1000000] of byte;

  i, fsize1, fsize2, fsize3, offset : int64;

begin
  // quick check parameters
  ErrorMsg:=CheckOptions('h', 'help');
  if ErrorMsg<>'' then begin
    ShowException(Exception.Create(ErrorMsg));
    Terminate;
    Exit;
  end;

  // parse parameters
  if HasOption('h', 'help') then begin
    WriteHelp;
    Terminate;
    Exit;
  end;


//************* MAIN PROGRAMM **********************************************
fsize1 := 0;
fsize2 := 0;
fsize3 := 0;
offset := 0;


  AssignFile (Fin1, Paramstr(1));             // first file in command line
                                              // parametrs - target for
                                              // patchig
  Reset (Fin1,1);

  if FileExists(Paramstr(1)) then
  fsize1 := FileSize(Fin1);                    // size of first file

  if fsize1 = 0 then
     begin
          writeln('Error in parametr 1 - file ', paramstr(1));
          Terminate;
          Exit;
     end;

  i := 0;
  while i < fsize1 do
        begin
             BlockRead(Fin1, buffer[i], 1, NumRead);   // Reading first file in to
                                                       // buffer
             inc(i);
        end;
  WriteLn ('Readed ', inttostr(i), ' bytes from file ', paramstr(1));
  close(Fin1);

  fsize1 := i;  // реальное число считанных байт из файла 1

//*************
  AssignFile (Fin2, Paramstr(2));             // second file in command line
                                              // parametrs - data for
                                              // patchig
  Reset (Fin2,1);
  if FileExists(Paramstr(2)) then
  fsize2 := FileSize(Fin2);

  if fsize2 = 0 then
     begin
          writeln('Error in parametr 2 - file ', paramstr(2));
          Terminate;
          Exit;
     end;

  try
       offset:= strtoint(Paramstr(3));
  // $0F070; offset in file 1 for patching
  except
        begin
             writeln('Error in parametr 3 (offset) ', paramstr(3));
             Terminate;
             Exit;
        end;
  end;

  i := 0;
    while i < fsize2 do
        begin
             BlockRead(Fin2, buffer[i+offset], 1, NumRead);   // Reading second file in
             inc(i);
        end;
  WriteLn ('Readed ', inttostr(i) ,' bytes from file ', paramstr(2), 'to buffer from offset ',
  inttostr(offset));
  close(Fin2);
  fsize2:=i;  // реальное число считанных байт из файла 2


//*************
  AssignFile (Fout,Paramstr(4));
  Rewrite (Fout,1);

  i := 0;
  while i < fsize1 do
        begin
             BlockWrite(Fout, buffer[i], 1, NumWritten);   // Writing output file 3 (paramstr 4)
             inc(i);
        end;
  WriteLn ('Writed ', inttostr(i), ' bytes to file ', paramstr(4));
  close(Fout);
  fsize3 := i;  // реальное число записанных байт в файл 3

  if fsize3 <> fsize1 then
     begin
          WriteLn ('ERROR to write output file ', paramstr(3), '!!!!');
          WriteLn ('Expected file size: ', inttostr(fsize1));
          WriteLn ('Real file size:     ', inttostr(fsize3));
          Terminate;

     end;

  // stop program loop
  Terminate;

end;

constructor TMyApplication.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

destructor TMyApplication.Destroy;
begin
  inherited Destroy;
end;

procedure TMyApplication.WriteHelp;
begin
  { add your help code here }
//  writeln('Usage: ', ExeName, ' -h');
  writeln('Usage: ', ExeName, ' Input target file (ROMDISK.BIN), patch file (MBOOT2.BIN)',
  'offset in target file, Output file (ROMDISKn.BIN)');

end;

var
  Application: TMyApplication;
begin
  Application:=TMyApplication.Create(nil);
  Application.Title:='Patcher for Orion ROM-DISK';
  Application.Run;
  Application.Free;
end.

